<template>
  <v-container>
    <v-dialog v-model="renameDialog" @click:outside="close" @keydown.esc="close" max-width="450px">
      <v-card>
        <v-card-title>
          <v-row justify="center">
            <v-icon
              v-if="!itemToRename.extension && !itemToRename.link"
              class="iconDeleteTitle"
              x-large
              color="primary"
              >mdi-folder-edit</v-icon
            >
            <v-icon v-if="itemToRename.extension" class="iconDeleteTitle" x-large color="primary"
              >mdi-file-edit</v-icon
            >
            <v-icon v-if="itemToRename.link" class="iconDeleteTitle" x-large color="primary"
              >mdi-link-variant</v-icon
            >
          </v-row>
        </v-card-title>
        <v-card-title>
          <v-row justify="center">
            <span class="deleteTitleFont">Deseja renomear "{{ itemToRename.name }}" ?</span>
          </v-row>
        </v-card-title>
        <v-card-text>
          <v-row justify="center">
            <v-col v-if="!itemToRename.extension && !itemToRename.link" cols="10">
              <v-text-field
                autofocus
                v-model="name"
                :error-messages="errorMessage"
                label="Novo nome do diretório"
                @keydown="cleanErrorMessage"
              ></v-text-field>
            </v-col>
            <v-col v-if="itemToRename.extension" cols="10">
              <v-text-field
                autofocus
                v-model="name"
                :error-messages="errorMessage"
                @keydown="cleanErrorMessage"
                label="Novo nome do arquivo"
              ></v-text-field>
            </v-col>
            <v-col v-if="itemToRename.link" cols="10">
              <v-text-field
                autofocus
                v-model="name"
                :error-messages="errorMessage"
                @keydown="cleanErrorMessage"
                label="Nome do link"
              ></v-text-field>
            </v-col>
            <v-col v-if="itemToRename.link" cols="10">
              <v-text-field
                v-model="link"
                :error-messages="errorMessage"
                @keydown="cleanErrorMessage"
                label="Url do link"
              ></v-text-field>
            </v-col>
          </v-row>
          <v-card-actions>
            <v-row justify="end">
              <v-btn
                :disabled="!name"
                color="primary"
                class="ml-4"
                elevation="0"
                @click="renameItem"
                >Sim</v-btn
              >
              <v-btn color="primary" text @click="close">Não</v-btn>
            </v-row>
          </v-card-actions>
        </v-card-text>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
export default {
  name: 'RenameItemDialog',

  props: {
    renameDialog: {
      type: Boolean,
      default: false,
    },
    itemToRename: {
      type: Object,
    },
    files: {
      type: Array,
    },
    folders: {
      type: Array,
    },
  },
  data: () => ({
    name: '',
    link: '',
    errorMessage: '',
  }),

  computed: {},
  watch: {
    itemToRename() {
      this.name = this.itemToRename.name
      if (this.itemToRename.link) this.link = this.itemToRename.link
    },
  },

  methods: {
    close() {
      this.$emit('closeRenameDialog')
      this.name = this.itemToRename.name
      this.errorMessage = ''
    },
    renameItem() {
      let check = 0
      if (this.itemToRename.extension) {
        this.files.forEach((e) => {
          if (e.name == this.name && e.extension == this.itemToRename.extension) {
            check++
            this.errorMessage =
              'Já existe um arquivo ' + e.extension + ' com esse nome no diretório atual'
            return
          }
        })
      } else {
        this.folders.forEach((e) => {
          if (e.name == this.name) {
            check++
            this.errorMessage = 'Já existe um diretório com esse nome'
            return
          }
        })
      }
      if (this.name == '') {
        this.errorMessage = 'Não é possível renomear para um nome vazio'
        return
      }
      if (check == 0) {
        let rename = { name: this.name, link: this.link }
        this.$emit('renameItem', rename)
        this.name = ''
        this.link = ''
        this.errorMessage = ''
      }
    },
    cleanErrorMessage() {
      this.errorMessage = ''
    },
  },
}
</script>
<style>
.deleteTitleFont {
  transform: scale(0.75);
}
.iconDeleteTitle {
  padding-top: 15px;
  transform: scale(1.5);
}
</style>
